component {

	property name="productService" inject;
	property name="categoryService" inject;

	public void function index(event,rc,prc){
		setNextEvent("product/list");
	}
	
	public void function list(event,rc){
		rc.products = productService.list(asquery=false);
		event.setView("product/products");
	}
	
	public void function edit(event,rc){   
		if( !structKeyExists(rc,"product")){
	        rc.product = productService.get( event.getValue('product_id','') );
		} 
        rc.categories = categoryService.list(asquery=false);
        event.setView("product/product");		
	}
	
	public void function save(event,rc){
		// populate the model with all the properties		
		rc.product = populateModel( model=productService.get(rc.product_id) );
		
		if( structKeyExists(rc,"categories") ){
			rc.product.setCategories( categoryService.loadById(rc.categories) );
		}
	
		// validation
		var result = validateModel(rc.product);
		
		if( !result.hasErrors() ){
			// validation found no errors, persist the data
			productService.save(rc.product);
			getPlugin("MessageBox").setMessage("info","Product saved!");	
			setNextEvent('product/list');	
		} else {
			getPlugin("MessageBox").setMessage(type="error",messageArray=result.getAllErrors());
			setNextEvent(event='product/edit',persist="product");			
		}
		
	}		

}